# -------------------------------------------------------------------------------------------------
#  Copyright (C) 2015-2021 Nautech Systems Pty Ltd. All rights reserved.
#  https://nautechsystems.io
#
#  Licensed under the GNU Lesser General Public License Version 3.0 (the "License");
#  You may not use this file except in compliance with the License.
#  You may obtain a copy of the License at https://www.gnu.org/licenses/lgpl-3.0.en.html
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
# -------------------------------------------------------------------------------------------------

# isort:skip_file

"""Provides the C Enums as Python Enums for external use."""

from nautilus_trader.model.c_enums.account_type import AccountType                         # noqa F401 (being used)
from nautilus_trader.model.c_enums.account_type import AccountTypeParser                   # noqa F401 (being used)
from nautilus_trader.model.c_enums.aggressor_side import AggressorSide                     # noqa F401 (being used)
from nautilus_trader.model.c_enums.aggressor_side import AggressorSideParser               # noqa F401 (being used)
from nautilus_trader.model.c_enums.asset_class import AssetClass                           # noqa F401 (being used)
from nautilus_trader.model.c_enums.asset_class import AssetClassParser                     # noqa F401 (being used)
from nautilus_trader.model.c_enums.asset_type import AssetType                             # noqa F401 (being used)
from nautilus_trader.model.c_enums.asset_type import AssetTypeParser                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.bar_aggregation import BarAggregation                   # noqa F401 (being used)
from nautilus_trader.model.c_enums.bar_aggregation import BarAggregationParser             # noqa F401 (being used)
from nautilus_trader.model.c_enums.currency_type import CurrencyType                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.currency_type import CurrencyTypeParser                 # noqa F401 (being used)
from nautilus_trader.model.c_enums.depth_type import DepthType                             # noqa F401 (being used)
from nautilus_trader.model.c_enums.depth_type import DepthTypeParser                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.instrument_close_type import InstrumentCloseType        # noqa F401 (being used)
from nautilus_trader.model.c_enums.instrument_close_type import InstrumentCloseTypeParser  # noqa F401 (being used)
from nautilus_trader.model.c_enums.instrument_status import InstrumentStatus               # noqa F401 (being used)
from nautilus_trader.model.c_enums.instrument_status import InstrumentStatusParser         # noqa F401 (being used)
from nautilus_trader.model.c_enums.liquidity_side import LiquiditySide                     # noqa F401 (being used)
from nautilus_trader.model.c_enums.liquidity_side import LiquiditySideParser               # noqa F401 (being used)
from nautilus_trader.model.c_enums.oms_type import OMSType                                 # noqa F401 (being used)
from nautilus_trader.model.c_enums.oms_type import OMSTypeParser                           # noqa F401 (being used)
from nautilus_trader.model.c_enums.order_side import OrderSide                             # noqa F401 (being used)
from nautilus_trader.model.c_enums.order_side import OrderSideParser                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.order_state import OrderState                           # noqa F401 (being used)
from nautilus_trader.model.c_enums.order_state import OrderStateParser                     # noqa F401 (being used)
from nautilus_trader.model.c_enums.order_type import OrderType                             # noqa F401 (being used)
from nautilus_trader.model.c_enums.order_type import OrderTypeParser                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.book_level import BookLevel                             # noqa F401 (being used)
from nautilus_trader.model.c_enums.book_level import BookLevelParser                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.delta_type import DeltaType                             # noqa F401 (being used)
from nautilus_trader.model.c_enums.delta_type import DeltaTypeParser                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.position_side import PositionSide                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.position_side import PositionSideParser                 # noqa F401 (being used)
from nautilus_trader.model.c_enums.price_type import PriceType                             # noqa F401 (being used)
from nautilus_trader.model.c_enums.price_type import PriceTypeParser                       # noqa F401 (being used)
from nautilus_trader.model.c_enums.time_in_force import TimeInForce                        # noqa F401 (being used)
from nautilus_trader.model.c_enums.time_in_force import TimeInForceParser                  # noqa F401 (being used)
from nautilus_trader.model.c_enums.venue_status import VenueStatus                         # noqa F401 (being used)
from nautilus_trader.model.c_enums.venue_status import VenueStatusParser                   # noqa F401 (being used)
from nautilus_trader.model.c_enums.venue_type import VenueType                             # noqa F401 (being used)
from nautilus_trader.model.c_enums.venue_type import VenueTypeParser                       # noqa F401 (being used)
